; extended_tsr_and_pop()

_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

DGROUP  GROUP   _TEXT, _DATA

_DATA   SEGMENT WORD PUBLIC 'DATA'
        EXTRN   _heap_top:WORD
_DATA   ENDS

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        PUBLIC  _extended_tsr_and_pop

HOT_KEY DW      (?)
TSRACT  DB      0
HOLDSP  DW      (?)
HOLDSS  DW      (?)
HOLDBX  DW      (?)
HOLDCX  DW      (?)
HOLDDX  DW      (?)
HOLDSI  DW      (?)
HOLDDI  DW      (?)
HOLDBP  DW      (?)
HOLDDS  DW      (?)
HOLDES  DW      (?)


_extended_tsr_and_pop PROC NEAR

        PUSH    BP
        MOV     BP,SP
        PUSH    SI
        PUSH    DI
        MOV     AX,[BP+4]
        MOV     HOT_KEY,AX
        CMP     TSRACT,0
        JZ      PTSR

_extended_tsr_and_pop ENDP

; reexit after TSR active session

REEXIT  PROC    FAR

        MOV     TSRACT,0
        MOV     BX,HOLDBX
        MOV     CX,HOLDCX
        MOV     DX,HOLDDX
        MOV     SI,HOLDSI
        MOV     DI,HOLDDI
        MOV     BP,HOLDBP
        MOV     ES,HOLDES
        CLI
        XCHG    SP,HOLDSP
        MOV     AX,SS
        XCHG    AX,HOLDSS
        MOV     SS,AX
        STI
        MOV     DS,HOLDDS
        SUB     AX,AX           ; tell interrupted program there
        RET     2               ; was no keystroke

REEXIT  ENDP


; Patch interrupt vector and do a TSR system call

PTSR:   MOV     AX,3516H
        INT     21H
        MOV     INTOFS,BX
        MOV     INTSEG,ES
        MOV     AX,2516H
        MOV     DX,OFFSET DGROUP:INT16
        INT     21H
        MOV     HOLDSP,SP
        MOV     HOLDSS,SS
        MOV     DX,_heap_top
        ADD     DX,15
        RCR     DX,1
        MOV     CL,3
        SHR     DX,CL
        MOV     AX,3100H
        INT     21H

; handle INT 16H

        ASSUME  DS:NOTHING

INT16   PROC    FAR

        STI                     ; re-enable interrupts
        CMP     TSRACT,0
        JNZ     OLDINT          ; do not interfere when TSR is active
        CMP     AH,11H
        JZ      FUNC11
        CMP     AH,10H
        JNZ     OLDINT          ; handle only functions 10H and 11H
FUNC10: MOV     AH,11H          ; function 10H
        INT     16H
        JZ      FUNC10
        MOV     AH,10H
OLDINT:
        DB      0EAH            ; opcode for far jump
INTOFS  DW      (?)
INTSEG  DW      (?)

FUNC11: PUSHF                   ; function 11H
        PUSH    CS
        CALL    OLDINT          ; first call old INT 16
        JZ      EXIT            ; if no key, pass result on
        CMP     AX,HOT_KEY      ; if key not hot key, pass on
        JZ      REENTER
EXIT:   RET     2

INT16   ENDP

; reenter program after hot key struck

REENTER PROC    NEAR

        MOV     HOLDDS,DS
        MOV     AX,CS
        MOV     DS,AX
        ASSUME  DS:DGROUP
        MOV     HOLDBX,BX
        MOV     HOLDCX,CX
        MOV     HOLDDX,DX
        MOV     HOLDSI,SI
        MOV     HOLDDI,DI
        MOV     HOLDBP,BP
        MOV     HOLDES,ES
        CLI
        XCHG    SP,HOLDSP
        MOV     AX,SS
        XCHG    AX,HOLDSS
        MOV     SS,AX
        STI
        MOV     TSRACT,1
        MOV     AH,10H          ; remove hot key from buffer
        INT     16H
        POP     DI
        POP     SI
        POP     BP
        RET     

REENTER ENDP

_TEXT   ENDS
        END

