; free()

BLOCK   STRUC
SIZALL  DW      (?)     ; size and allocation
PREV    DW      (?)     ; previous free block
NEXT    DW      (?)     ; next free block
BLOCK   ENDS

_TEXT   SEGMENT BYTE PUBLIC 'CODE'
_TEXT   ENDS

_DATA   SEGMENT WORD PUBLIC 'DATA'
        EXTRN   _heap_top:WORD
        EXTRN   _heap_bottom:WORD
        EXTRN   __endfree:BLOCK
_DATA   ENDS

FIRSTFREE       EQU     __endfree.NEXT

DGROUP  GROUP   _TEXT, _DATA

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        PUBLIC  _free

_free   PROC NEAR

        PUSH    SI
        PUSH    DI
        MOV     BX,SP
        MOV     SI,[BX+6]
        DEC     SI
        DEC     SI              ; SI -> block to be freed
        MOV     CX,[SI].SIZALL
        DEC     CX              ; CX = length of block
        MOV     DI,SI
        ADD     DI,CX           ; DI -> next higher block
        CMP     DI,_heap_top
        JE      FREE2           ; there is no higher block
        TEST    WORD PTR [DI].SIZALL,1
        JNZ     FREE2           ; next higher block is not free
        MOV     BX,[DI].PREV    ; remove next higher block from free list
        MOV     AX,[DI].NEXT
        MOV     [BX].NEXT,AX
        MOV     BX,[DI].NEXT
        MOV     AX,[DI].PREV
        MOV     [BX].PREV,AX
        ADD     CX,[DI]         ; add next higher block to this one

FREE2:  CMP     SI,_heap_bottom
        JE      FREE3           ; there is no lower block
        MOV     DI,SI
        SUB     DI,[SI-2]       ; DI -> next lower block
        TEST    WORD PTR [DI].SIZALL,1
        JNZ     FREE3           ; next lower block is not free
        MOV     BX,[DI].PREV    ; remove next lower block from free list
        MOV     AX,[DI].NEXT
        MOV     [BX].NEXT,AX
        MOV     BX,[DI].NEXT
        MOV     AX,[DI].PREV
        MOV     [BX].PREV,AX
        ADD     CX,[DI].SIZALL  ; add next lower block to this one
        MOV     SI,DI

FREE3:  MOV     [SI],CX         ; free this block
        MOV     BX,CX
        MOV     [SI+BX-2],CX
                                ; put this block into the free chain
        MOV     [SI].PREV,OFFSET DGROUP:__endfree
        MOV     BX,FIRSTFREE    ; BX -> first free block
        MOV     [SI].NEXT,BX
        MOV     FIRSTFREE,SI
        MOV     [BX].PREV,SI

        POP     DI
        POP     SI
        RET

_free   ENDP

_TEXT   ENDS
        END

