/* linked_list_sort_far() */

#include <tt.h>

void far *linked_list_sort_far(void far *p, unsigned index, int (*compare)())
{
  unsigned base;
  unsigned block_size;

  struct element
  {
    struct element far *next[1];
    /* other members not directly accessed by linked_list_sort() */
  };

  struct tape
  {
    struct element far *first, far *last;
    unsigned count;
  } tape[4];

  if (p==FAR_NULL) return FAR_NULL;
  if (((struct element far *)p)->next[index]==FAR_NULL) return p;

  tape[0].count = tape[1].count = 0;

  base = 0;
  do
  {
    struct element far *next = ((struct element far *)p)->next[index];
    ((struct element far *)p)->next[index] = tape[base].first;
    tape[base].first = ((struct element far *)p);
    tape[base].count++;
    p = next;
    base^=1;
  } while (p!=FAR_NULL);

  if (tape[0].count==0) return FAR_NULL;
  if (tape[1].count==0) return tape[0].first;

  for (base=0, block_size=1; tape[base+1].count!=0; base^=2, block_size<<=1)
  {
    int dest;
    struct tape *tape0, *tape1;
    tape0 = tape + base;
    tape1 = tape + base + 1;
    dest = base^2;
    tape[dest].count = tape[dest+1].count = 0;
    for (; tape0->count!=0; dest^=1)
    {
      unsigned n0, n1;
      struct tape *output_tape = tape + dest;
      n0 = n1 = block_size;
      while (1)
      {
        struct element far *chosen_element;
        struct tape *chosen_tape;
        if (n0==0 || tape0->count==0)
        {
          if (n1==0 || tape1->count==0) break;
          chosen_tape = tape1;
          n1--;
        }
        else if (n1==0 || tape1->count==0)
        {
          chosen_tape = tape0;
          n0--;
        }
        else if ((*compare)(tape0->first,tape1->first)>0)
        {
          chosen_tape = tape1;
          n1--;
        }
        else
        {
          chosen_tape = tape0;
          n0--;
        }
        chosen_tape->count--;
        chosen_element = chosen_tape->first;
        chosen_tape->first = chosen_element->next[index];
        if (output_tape->count==0) output_tape->first = chosen_element;
        else output_tape->last->next[index] = chosen_element;
        output_tape->last = chosen_element;
        output_tape->count++;
      }
    }
  }

  tape[base].last->next[index] = FAR_NULL;
  return tape[base].first;
}
