/* set_timeout(), timeout() */

#include <tt.h>
#pragma inline

unsigned remaining_time;
static unsigned char previous_reading;

void set_timeout(unsigned time_limit)
{
  remaining_time = time_limit;
  /* this DOS call returns hundredths of a second in DL */
  _AH = 0x2C;
  asm int 33;
  previous_reading = _DL;
}

boolean timeout(void)
{
  /* this DOS call returns hundredths of a second in DL */
  _AH = 0x2C;
  asm int 33;
  _AL = _DL;
  /* number of hundredths of a second elapsed since previous call */
  _AL -= previous_reading;
  previous_reading = _DL;
  asm jnc timeout2;
  _AL += 100;
  timeout2:
  /* extend to a full word */
  _AH = 0;
  /* subtract from remaining time */
  remaining_time -= _AX;
  /* the first time the time limit is reached, AX must be nonzero */
  asm jbe timeout3;
  _AX = 0;
  timeout3:
  ;
}
