;  Plain Vanilla TT LIbrary 1.2 C Setup

_TEXT   SEGMENT BYTE PUBLIC 'CODE'      ; code segment
_TEXT   ENDS
_DATA   SEGMENT WORD PUBLIC 'DATA'      ; initialized data segment
_DATA   ENDS
_BSS    SEGMENT WORD PUBLIC 'BSS'       ; uninitialized data segment
BSSBEGIN:                               ; marks beginning of _BSS
_BSS    ENDS
_BSSEND SEGMENT WORD PUBLIC 'BSSEND'    ; marks end of _BSS
BSSEND:
_BSSEND ENDS

DGROUP  GROUP   _TEXT, _DATA, _BSS, _BSSEND

_DATA           SEGMENT

                EXTRN   _stack_size:WORD
                EXTRN   _program_name:BYTE
                PUBLIC  ___brklvl, _heap_bottom, _heap_top

___brklvl       DW      OFFSET DGROUP:BSSEND    ; stack limit
_heap_bottom    DW      (?)
_heap_top       DW      (?)
ISM             DB      'Insufficient Memory', 0
COLON           DB      ': ', 0
STARS           DB      ' ****** ', 13, 10, 0

_DATA           ENDS

_TEXT   SEGMENT
        ASSUME  CS:DGROUP, DS:DGROUP

        EXTRN   _main:NEAR

        ORG     100H

BEGIN:  JMP SHORT BEGIN2                ; jump over copyright notice
        DB      13, 10, 'Copyright 1993 Plain Vanilla Corp., '
        DB      'Box 4493, San Diego CA 92164', 0, 26
BEGIN2: MOV     _heap_top,SP            ; highest near address
        MOV     BX,OFFSET DGROUP:BSSEND
        ADD     BX,_stack_size          ; desired SP
        JC      _insufficient_memory     ; overflows 64K
        CMP     BX,SP
        JA      _insufficient_memory     ; insufficient memory for stack
        MOV     _heap_bottom,BX
        MOV     SP,BX
        ADD     BX,16
        JC      _insufficient_memory     ; insufficient memory for heap
        CMP     BX,_heap_top
        JA      _insufficient_memory     ; insufficient memory for heap
        MOV     CL,4
        SHR     BX,CL
        MOV     AH,4AH
        INT     21H                     ; release memory above new SP
        MOV     CX,OFFSET DGROUP:BSSEND
        MOV     DI,OFFSET DGROUP:BSSBEGIN
        SUB     CX,DI
        JZ      BEGIN3
        SUB     AX,AX
        CLD
        REP     STOSB                   ; clear _BSS segment
BEGIN3: CALL    _main
        MOV     AX,4C00H                ; return with ERRORLEVEL 0
        INT     21H

        PUBLIC  _insufficient_memory

_insufficient_memory:
        MOV     SI,OFFSET DGROUP:ISM
        JMP SHORT ERREX2

        PUBLIC  _error_exit

_error_exit:
        POP     SI
        POP     SI                      ; error message -> SI
ERREX2: MOV     AX,OFFSET DGROUP:_program_name
        PUSH    AX
        CALL    _error_output_string    ; display program name
        MOV     AX,OFFSET DGROUP:COLON
        PUSH    AX
        CALL    _error_output_string    ; display ': '
        PUSH    SI
        CALL    _error_output_string    ; display error message
        MOV     AX,OFFSET DGROUP:STARS
        PUSH    AX
        CALL    _error_output_string    ; display ' ****** '
        MOV     AX,4C01H
        INT     21H                     ; return with ERRORLEVEL 1

        PUBLIC  _error_output_string
        PUBLIC  __output_string

_error_output_string PROC NEAR

        MOV     CX,2                    ; standard error handle

__output_string:                        ; enter here to output a string
                                        ;   to handle in CX
        MOV     BX,SP
        MOV     DX,[BX+2]               ; string -> DX
        MOV     BX,DX
        CMP     BYTE PTR [BX],0         ; is the string empty?
        JE      EOS3                    ; if so, skip the output
EOS2:   INC     BX
        CMP     BYTE PTR [BX],0         ; find end of string
        JNE     EOS2
        SUB     BX,DX                   ; string length -> BX
        XCHG    CX,BX                   ; string length -> CX
        MOV     AH,40H                  ;   handle -> BX
        INT     21H
EOS3:   RET

_error_output_string ENDP

_TEXT   ENDS

        END     BEGIN
